'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('next/dist/lib/router/index.js');

var _index2 = _interopRequireDefault(_index);

var _auth0Lock = require('auth0-lock');

var _auth0Lock2 = _interopRequireDefault(_auth0Lock);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Use as simple link wrapper
// <Lock redirect="/here">A link</Lock>
// Custom usage
// <Lock redirect="/here" children={({show, hide})=>(<a onClick={show} href="/login">My Login</a>)} />
// <Lock ready={(lock)=>{lock.show()}} />

var Lock = function (_React$Component) {
  (0, _inherits3.default)(Lock, _React$Component);

  function Lock(props) {
    (0, _classCallCheck3.default)(this, Lock);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Lock.__proto__ || (0, _getPrototypeOf2.default)(Lock)).call(this, props));

    _this.onAuthenticated = function (authResult) {
      //console.log('authenticated',authResult);
      try {
        window.localStorage.setItem('auth0IdToken', authResult.idToken);
      } catch (e) {
        _this.lock && _this.lock.show({
          flashMessage: {
            type: 'error',
            text: 'You must allow your browser to use local storage to login.'
          }
        });
      }

      // Redirect to verify or create user
      _index2.default.replace(_this.props.login + '?verify');
    };

    _this.onError = function (error) {
      //console.log('auth error', error);

      //window.localStorage.removeItem('auth0IdToken');
      //window.localStorage.removeItem('auth0Redirect');

      _this.lock && _this.lock.show({
        flashMessage: {
          type: 'error',
          text: 'There was an error, please try again.'
        }
      });
    };

    _this.show = function () {
      var redirect = _this.props.redirect;

      try {
        window.localStorage.setItem('auth0Redirect', redirect);
        _this.lock && _this.lock.show();
      } catch (e) {
        _this.lock && _this.lock.show({
          flashMessage: {
            type: 'error',
            text: 'You must allow your browser to use local storage to login.'
          }
        });
      }
    };

    _this.hide = function () {
      _this.lock && _this.lock.hide();
    };

    _this.onClick = function (e) {
      e.preventDefault();
      _this.show();
    };

    return _this;
  }

  (0, _createClass3.default)(Lock, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      // Cross-browser window.origin
      var origin = window.location.protocol + "//" + window.location.hostname + (window.location.port ? ':' + window.location.port : '');

      // Configure Auth0 instance
      this.lock = this.lock || new _auth0Lock2.default(this.props.authId, this.props.authDomain, (0, _extends3.default)({
        auth: {
          redirectUrl: origin + this.props.login,
          responseType: 'token'
        },
        theme: {
          primaryColor: '#5E2CA5'
        }
      }, this.props.options));

      this.lock.on('authenticated', this.onAuthenticated);
      this.lock.on('unrecoverable_error', this.onError);

      _index2.default.onRouteChangeStart = function () {
        _this2.lock && _this2.lock.hide();
      };

      this.props.ready && this.props.ready(this);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.lock && this.lock.hide();
    }
  }, {
    key: 'render',
    value: function render() {
      // Extract props we don't want to passthrough
      var _props = this.props,
          ready = _props.ready,
          login = _props.login,
          redirect = _props.redirect,
          authId = _props.authId,
          authDomain = _props.authDomain,
          passThroughProps = (0, _objectWithoutProperties3.default)(_props, ['ready', 'login', 'redirect', 'authId', 'authDomain']);

      var children = this.props.children;

      if (typeof children === 'function') {
        // Custom children
        return children({
          show: this.show,
          hide: this.hide
        });
      } else {
        // Create a link with fallback
        return _react2.default.createElement('a', (0, _extends3.default)({}, passThroughProps, { href: login, onClick: this.onClick }));
      }
    }
  }]);

  return Lock;
}(_react2.default.Component);

Lock.defaultProps = {
  login: '/login',
  redirect: '/',
  authId: process.env.AUTH0_ID,
  authDomain: process.env.AUTH0_DOMAIN
};

exports.default = Lock;